// bubu321, 2022.11.10, ssid, passwd Wifi w pliku <credentails.h> lub w "nasze_dane.h"
// haslo domyslne dla OTA to "admin"
				
#include <WiFi.h>
#include <ESPmDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>
	//	#include <credentals.h>
			
// ----------------
void beginOTA(){
	static bool pomin = 1;  			
	byte iNetwork = 1;
	uint8_t connectionStatus;
  IPAddress dns(8, 8, 8, 8); 												// Google DNS
    // WiFi.disconnect();
  WiFi.mode(WIFI_STA); 															// switch off AP
  //  WiFi.setAutoConnect(true);
  //  WiFi.setAutoReconnect(true);
			// Tu podajemy nazwe naszego nowego projektu (tak bedzie widoczny w ArduinoIDE)
  ArduinoOTA.setHostname("OTA_zegOTAx_");
				
	if (counter >= 1) {
		Serial.println("WiFi is OFF! Rebooting...");
		preferences.clear();
    delay(5000);
		ESP.restart();																// Restart ESP
	}
					
  Serial.printf("network %d ", iNetwork);      
	while ( WiFi.status() != WL_CONNECTED && (iNetwork <= NetworksNumber) ) {
	  //while ( WiFi.waitForConnectResult() != WL_CONNECTED && (iNetwork <= NetworksNumber) ) {
		unsigned long start = millis();
    Serial.printf("Connecting to %s ", ssid[iNetwork - 1]);
    WiFi.begin(ssid[iNetwork - 1], password[iNetwork - 1]);
		while (WiFi.status() != WL_CONNECTED && millis() - start < 10000 ) {			// timeout == 10 sek
      delay(200);
      // Serial.print("."); 
			Serial.print(WiFi.status());
    }
//	Serial.printf("\nWifi status %d \n", WiFi.status()); // 3 WL_CONNECTED, 4 WL_CONNECT_FAILED 6 WL_DISCONNECTING
		if (WiFi.status() != WL_CONNECTED) {
				//	iNetwork++;
	Serial.printf("\nnetwork %d ", iNetwork);		// 1 WL_NO_SSID_AVAIL 0 WiFi.begin() is called 5 WL_CONNECTION_LOST
			if (iNetwork > NetworksNumber) connectionStatus == WL_CONNECT_FAILED; // No network found
			delay(5000);
      ESP.restart();
		}
	}	// ------------ end_while ----------------
	connectionStatus = WiFi.status();	
	// --------------------------------------------------------------------------		
  if (connectionStatus == WL_CONNECTED) {
    wifi_signal = WiFi.RSSI(); 														// Get Wifi Signal strength now.
    Serial.print(" WiFi connected at: " + WiFi.localIP().toString());
		wifiBrak = 0;
  }
  else {
		Serial.println(" WiFi connection *** FAILED ***");
		wifiBrak = 1;
	}	
  		
  // Tu podajemy nazwe naszego nowego projektu (tak bedzie widoczny w ArduinoIDE)
  //ArduinoOTA.setHostname("OTA_zegOTAx_");
			
  // Jezeli chcemy haslo, korzystamy z jednej z ponizszych linii
   //ArduinoOTA.setPassword("admin");
  // ArduinoOTA.setPasswordHash("21232f297a57a5a743894a0e4a801fc3");
			
  ArduinoOTA
    .onStart([]() {
      String type;
      if (ArduinoOTA.getCommand() == U_FLASH)
        type = "sketch";
      else // U_SPIFFS
        type = "filesystem";
				Serial.println("Start updating " + type);
    })
    .onEnd([]() {
      Serial.println("\nEnd");
      valueDim = 0;
      pendantColor.R = 0;                                  // wahadlo zgas 
      pendantColor.G = 0;
      pendantColor.B = 0;
      secondHandColor.R = 0;                              // sekundy zgas
      secondHandColor.G = 0;
      secondHandColor.B = 0;
      totalBrightness = 0;  
    })
    .onProgress([](unsigned int progress, unsigned int total) {
      Serial.printf( "Progress: %u%%\r",  progress  /( total / 100 ));       // org /100
    })
    .onError([](ota_error_t error) {
      Serial.printf("Error[%u]: ", error);
      if (error == OTA_AUTH_ERROR) Serial.println("Auth Failed");
      else if (error == OTA_BEGIN_ERROR) Serial.println("Begin Failed");
      else if (error == OTA_CONNECT_ERROR) Serial.println("Connect Failed");
      else if (error == OTA_RECEIVE_ERROR) Serial.println("Receive Failed");
      else if (error == OTA_END_ERROR) Serial.println("End Failed");
    });
  ArduinoOTA.begin();
}	// ------------------- beginOTA_end ----------------------
				
	// ---------------------------
 void obslugaOTA(){
      ArduinoOTA.handle();
 }
		
