// [1815] setup   [2088] loop [451]loop for core 0 [444] setTIME [668] checkAutoDIM 
// add 
// w pliku wifiOTA.ino zmien linie "ArduinoOTA.setHostname("OTA_zegOTAx_");"
// DFRobotDFPlayerMini, check if library is Makuna_NeoPixelBus ver. 2.7.0
// Szkic używa 1511137 bytes (76%) pamięci programu. Maksimum to 2097152 bajtów.
// Zmienne globalne używają 54616 bajtów (16%) pamięci dynamicznej, pozostawiając 274076 bajtów dla zmiennych 
// lokalnych. Maksimum to 327680 bajtów.
// z pliku zeg21.ino, Ws2812 zasilane z +5V.
// bubu321, 2022.11.09, file: zegOTA10.ino, shield WEMOS Lolin32 flash 4MB, fonty http://oleddisplay.squix.ch/#/home
// menadzer plytek : esp32 Lolin 32 versja 2.01 (1.06), tryb partycji: minimal SPIFFS, large App with OTA.
// CPU Frequency 240MHz (WiFi/BT)
// program bazowal na programie # K2400-BrightDot-Clock.
// program byl sprawdzony na Arduino wersja 1.8.20 oraz dla Arduino wersja 2.01.
			
/* piny
	 RX 14 TX 15 SDA 13 SCL 16 RGB 4	EN rst OLED IRout 27
*/
		
/*  IR code by NEC
0   0xFF6897		repeat 16 x 0xFF
1		0xFF30CF
2   0xFF18E7 				
3		0xFF7A85
4		0xFF10EF
5		0xFF38C7
6		0xFF5AA5
7		0xFF42BD	
8		0xFF4AB5
9		0xFF52AD
100+ 0xFF9867
200+ 0xFFB04F
"-" 0xFFE01F
"+" 0xFFA857
EQ  0xFF906F
|<< 0xFF22DD					// all id 0xyyyyyD
|>> 0xFF02FD
>|| 0xFFC23D
CH- 0xFFA25D
CH  0xFF629D
CH+ 0xFFE21D
*/
		
//-------------------------------------------------------------------------------
// Allow over air update
#include <ArduinoOTA.h>
#include <Arduino.h>
#include <assert.h>
#include <IRrecv.h>												// TSOP 31236
#include <IRremoteESP8266.h>							// IRremoteESP8266 ver2.8.4 author=David Conran, ....
#include <IRac.h>
#include <IRtext.h>
#include <IRutils.h>
#include "U8g2lib.h"
#include <Preferences.h>
		
#include "nasze_dane.h"  									// enter your Wifi SSID and PASSWORD, Timezone, ntpserver
//	#include <NeoPixelBrightnessBus.h> 				// instead of NeoPixelBus.h nie dziala  ###
#include <NeoPixelBus.h>									// NeoPixelBus by Makuna ver. 2.7.0
#include <NeoPixelAnimator.h>							// by Makuna ver. 2.6.0
#include <WiFi.h>													// Built-in
#include <FS.h>
#include "time.h"													// Built-in
#include "soc/soc.h"											// brownout detector 
#include "soc/rtc_cntl_reg.h"
#include "esp_bt_main.h"									// BT out ?
#include "esp_bt.h"
	// #include "SSD1306Wire.h"  								// ESP8266 and ESP32 OLED driver for SSD1306 displays ver. 4.2.1
#include "SH1106Wire.h" 									// OLED 1.3"
#include "SoftwareSerial.h"               // EspSoftwareSerial ver. 6.15.1
#include "DFRobotDFPlayerMini.h"          // version=1.0.3 DFRobot
// #include <BH1750CLaws.h>									// BH1750 ver. 1.2.0 author=Christopher Laws
#include <ErriezBH1750.h>									// BH1750 ver. 1.1.2 author=Erriez
#include <forcedClimate.h>								// Forced-BME280 ver. 3.0 author=Jochem van Kranenburg
	//----------------------
#define MYPORT_RX 14											// 14, 15 serial for DFRobotDFPlayer Mp3
#define MYPORT_TX 15		
#define RECONINTERVAL 5
//	#define DEBUG  	1											// uncomment to enable debug messages over serial
#define I2C_SDA 	13											// 13 or 3
#define I2C_SCL 	16											// 16 for SSD1306 displays and BME280 climate sensor

RTC_DATA_ATTR int bootCount = 0;
			
	// ---------------------------	
const uint16_t PixelCount = 60;           // Number of pixels/LEDS in the clock
const uint8_t PixelPin = 4;               // data pin to which the LED strip is connected
		
//	const uint16_t AnimCount = 1; 						// we only need one
const uint16_t TailLength = 6; 						// length of the tail, must be shorter than PixelCount
const float MaxLightness = 0.1f; 					// ### max lightness at the head of the tail (0.5f is full bright)
const uint16_t AnimCount = PixelCount / 5 * 2 + 1; 		// need enough animations for the tail and one extra
unsigned long opoznienie = 0; 
const uint16_t PixelFadeDuration = 300; 									// third of a second
const uint16_t NextPixelMoveDuration = 1000 / PixelCount; // how fast we move through the pixels
const RgbColor CylonEyeColor(HtmlColor(0x7f0000));
		
const uint16_t kRecvPin = 27;										// IRQ to pin ,add 10k top VCC.
const uint16_t kCaptureBufferSize = 1024;				// see IRrecvDumpV3.ino
const uint8_t kTimeout = 15;
const uint16_t kMinUnknownSize = 12;
const uint8_t kTolerancePercentage = kTolerance;  // kTolerance is normally 25%
		
uint16_t lastPixel = 0; 													// track the eye position
int8_t moveDir = 1; 															// track the direction of movement
				
#define LEGACY_TIMING_INFO false
			
IRrecv irrecv(kRecvPin, kCaptureBufferSize, kTimeout, true); // Use turn on the save buffer feature.
decode_results results;  													// Somewhere to store the results
	// -------------------------------	
SoftwareSerial myPort; 
DFRobotDFPlayerMini myDFPlayer;		
Preferences preferences;
		
	// ------- globalne -------------
time_t now;			    															// this is the epoch
tm tm;  		
				
// BH1750 lightMeter(0x23);	
BH1750 sensor(LOW);
			
ForcedClimate climateSensor = ForcedClimate(Wire, 0x76, false);		// BME280
		
#ifdef DEBUG
 #define DEBUG_PRINT(x)     Serial.print (x)
 #define DEBUG_PRINTDEC(x)  Serial.print (x, DEC)
 #define DEBUG_PRINTLN(x)   Serial.println (x)
#else
 #define DEBUG_PRINT(x)
 #define DEBUG_PRINTDEC(x)
 #define DEBUG_PRINTLN(x) 
#endif 
				
		//String version = "0.37";    								// Version of this program
String version = "zegOTA10";                  // Version of this program			
int timeOUT = 20;														// 10 sekund.
int stanRGB = 2;
int lls = 4;																// LLS Low Level Sound
int poczAlarm = 0;
				
	//	-------------------------------------
TaskHandle_t LEDtask;                       //Handle name for LEDtask pinned to core
		
struct MyAnimationState
{
    RgbColor StartingColor;
    RgbColor EndingColor;
    uint16_t IndexPixel; 										// which pixel this animation is effecting
};
		
NeoPixelAnimator animations(AnimCount); 		// NeoPixel animation management object
MyAnimationState animationStateFun[AnimCount];
uint16_t frontPixel = 0;  									// the front of the loop
RgbColor frontColor;  											// the color at the front of the loop
		
// ------------------------------------------
  // SSD1306Wire  display(0x3c, I2C_SDA, I2C_SCL);  		// Initialize the OLED display using Wire library
	// SH1106Wire  display(0x3c, I2C_SDA, I2C_SCL);      // Initialize the OLED display using Wire library
#ifdef U8X8_HAVE_HW_SPI
#include <SPI.h>
#endif
#ifdef U8X8_HAVE_HW_I2C
#include <Wire.h>
#endif
// U8g2 Contructor List (Frame Buffer)
// The complete list is available here: https://github.com/olikraus/u8g2/wiki/u8g2setupcpp
// Please update the pin numbers according to your setup. Use U8X8_PIN_NONE if the reset pin is not connected
//U8G2_NULL u8g2(U8G2_R0);	// null device, a 8x8 pixel display which does nothing
	// --------------------------------------------------
//	U8G2_SSD1306_128X64_NONAME_F_SW_I2C u8g2(U8G2_R0, /* clock=*/ 13, /* data=*/ 11, /* reset=*/ 8);
//	U8G2_SSD1306_128X64_NONAME_F_SW_I2C u8g2(U8G2_R0, /* clock=*/ SCL, /* data=*/ SDA, /* reset=*/ U8X8_PIN_NONE);   // All Boards without Reset of the Display
// 	U8G2_SSD1306_128X64_NONAME_F_SW_I2C u8g2(U8G2_R0, /* clock=*/ 16, /* data=*/ 13, /* reset=*/ U8X8_PIN_NONE);   // ESP32 Thing, pure SW emulated I2C
U8G2_SSD1306_128X64_NONAME_F_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE, /* clock=*/ 16, /* data=*/ 13);   // ESP32 Thing, HW I2C with pin remapping
			
// ----------------------------------------------------------------------------------
		
		
uint8_t AlarmCount = 1;
		
bool pendantDir = true;                           //Direction of pendant animation           
int pendantTail = 5;                              //Fadeout number of the pendant tail
bool wahadlo = 1;
			
int secondHandTail = 1;                           //Fadeout number of the second hand tail
			
//bool fadeDir = true;                            //Fade direction for five minute marks           
//bool fadeDir2 = true;                           //Fade direction for quarter marks
			
int stateRGB = 2;                                 //Holds the global state for the clock
int rgbState = 2;			
int animationState = 1;                           //Holds the animation state for the clock
int stateAnimation = 7;
			
const int maxBrightness = 255;                    // the maximum brightness value must be 255
int totalBrightness = 15;  
int dimBrightness = 155;                          //Default value
int nightRGB = 1;																  // 1 value min 12 with dimBrightness = 155
uint8_t temp = totalBrightness;
																	// wahadlo dziala od total brightness == 13, dimBrightness == 255
int dimOn = 1;                                    //Is auto dimming on or off?
int hourStartDim = 19;                       	    // 19 - Start hour of auto dim night on - 1
int hourStopDim = 6;                              // 06 - Stop hour of auto dim nigth off
int valueDim = 10;                                //Value == BH1750Reading
			
bool night = 0;
bool nightOFF = 0;
bool ring = 0;
			
int checkPeriod = 1000;                           //Variable for timechecking delay
unsigned long checkTime_now = 0;                  //Variable for timechecking delay
			
int secCalc = 0;                                  //0-59 global second data gets updated every second
int minCalc = 0;                                  //0-59 global minutes data gets updated every second
int hourCalc = 0;                                 //0-59 global hour data gets updated every second 
int hourDirectCalc = 0;                           //0-23 global hour data gets updated every second
int minDirectCalc = 0; 
int secDirectCalc = 0; 			
int CurrentHour;
int CurrentMin;
int CurrentSec; 
			
bool WLANOn = false;                              //Are WIFI preferences stored or not?
bool onWiFi = 1;
String SSIDstring;                                //SSID string of network the clock will try to connect
String passwordstring;                            //password string of network the clock will try
String deviceName;                                //name of the device (can be changed by user). 
int wifi_signal;
int wifiBrak;
			
int alarmOn = 0;                                  //Is alarm on or off?
int minAlarm = 10;                                //Start minute of alarm
int hourAlarm = 19;                                //Start hour of alarm
#define DURATIONALARM 6                          	//How long does the alarm last
int durationAlarm;                                //variable for counting down
bool timeOFF = false;
			
int licznik15 = 15000;														// 15 sec. 
int delaylicznik7 = 7000;													// 7 sec.
int counter;																			// dla preferences
			
long unsigned int timeNow15;
long unsigned int timeNow5;
long unsigned int timeNow02;
unsigned long int tempTimer;
unsigned long czas1;
unsigned long czas1sek = 0;
unsigned long czasLoop = 0;
unsigned long tempLoop = 0;
			
int invert = 0;                                   //Inverts all the colors on the clockface
bool smartConfig = 0;                             //switches smartconfig on or off 
int reconnectCounter = 11;
		
int przejscie = 0;																// stan == 0
int licznik;
int llsTemp;
int stan = 0;
int katalog = 30;
int ile;
int plik;		
		
bool tylkoRaz = 1;
bool zero = 1;
bool jeden = 1;
bool dwa = 1;
bool trzy = 1;
bool cztery = 1;
bool piec = 1;
bool piec_siedem = 1;															// wykonaj raz sek 57_59
bool trzy_szesc = 1;
bool zeroS = 1;
bool jedenS = 1;
bool dwaS = 1;
bool trzyS = 1;
bool czteryS = 1;
bool one = 1;
bool two = 1;
bool podajCzas = 1;																// blokada podawania czasu. == 0
bool demo = 0;
bool demo1 = 1;
bool claps = 0;
bool stanMP3	= 0;																// 0 - gra, 1 - pause.
		
RgbColor pendantColor(0,0,0);                 // Default color of the pendant orig 0,0,0  
RgbColor fiveMinuteColor(0,0,0);              // Default color of the 5 minutes indication orig 0,0,0
RgbColor quarterColor(0,0,0);                 // Default color of the 15 minutes indication , orig 0,0,0
RgbColor quarterColor1(240,255,0);            // 150
RgbColor quarterColor2(240,255,0);            // 50
RgbColor secondHandColor(0,0,255);            // blue color of the second hand
RgbColor minuteHandColor(0,255,0);            // green color of the minute hand
RgbColor hourHandColor(255,0,0);              // red color of the hour hand
      
	//Different arrays to store the animations before blending
RgbColor animationArray1[60];                 // pendant, pendantTail [1491]
RgbColor animationArray2[60];									// fiveminute-marks			[1467]	
RgbColor animationArray3[60];									// second array					[1231]	
RgbColor animationArray4[60];									// minute array					[1036]
RgbColor animationArray5[60];									// hour array						[865]
RgbColor animationArray6[60];									// quarter-marks				[1436]
RgbColor animationArray7[60];									// alarm animation			[840]
		
int circleArray[61] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,0};
int fiveMinuteNumbers[] = {0,5,10,15,20,25,30,35,40,45,50,55}; // for NUm _LEDS == 60
int quarterNumbers[] = {0,15,30,45};
			
//---------------------------------------------
//  NeoPixelBrightnessBus<NeoRgbFeature, Neo800KbpsMethod> strip(PixelCount, PixelPin);	// 
// NeoPixelBus<NeoGrbFeature, NeoEsp32BitBang800KbpsMethod> strip(PixelCount, PixelPin);  // duze zaklocenia
//	NeoPixelBus<NeoGrbFeature, NeoEsp32Rmt7Ws2812xMethod> strip(PixelCount, PixelPin);
	NeoPixelBus<NeoGrbFeature, NeoEsp32Rmt0Ws2812xMethod> strip(PixelCount, PixelPin);	// org
		
NeoGamma<NeoGammaTableMethod> colorGamma;
	//	NeoPixelAnimator animations(14);								// org 12
  //  NeoPixelAnimator animations(AnimCount); 		// NeoPixel animation management object		
		
AnimEaseFunction animation1 = NeoEase::QuadraticInOut;
AnimEaseFunction animation2 = NeoEase::QuadraticInOut;
AnimEaseFunction animation3 = NeoEase::QuadraticInOut;
AnimEaseFunction animation4 = NeoEase::Linear;
AnimEaseFunction animation5 = NeoEase::QuadraticIn;
AnimEaseFunction moveEase =
//      NeoEase::Linear;
//      NeoEase::QuadraticInOut;
//      NeoEase::CubicInOut;
        NeoEase::QuarticInOut;
//      NeoEase::QuinticInOut;
//      NeoEase::SinusoidalInOut;
//      NeoEase::ExponentialInOut;
//      NeoEase::CircularInOut;
		
//--------------------------------- subroutine ----------------------------------
			
	// ------- prints leading 0 ----
String twoDigits(int digits) {
  if (digits < 10) {
    String i = '0' + String(digits);
    return i;
  }
  else {
    return String(digits);
  }
}

	// ----------------
int BH1750Reading()  {
	int lux = 0;
	if (sensor.isConversionCompleted()) {
    lux = sensor.read();										// Read light
	}
	return lux;
}	
				
	// -------------------
void SetRandomSeed()
{
  uint32_t seed;
					
			// random works best with a seed that can use 31 bits
			// analogRead on a unconnected pin tends toward less than four bits
  seed = analogRead(0);
  delay(1);
			
  for (int shifts = 3; shifts < 31; shifts += 3)
  {
    seed ^= analogRead(0) << shifts;
    delay(1);
  }
		// Serial.println(seed);
  randomSeed(seed);
}	
		
	// ---------------------
uint8_t StartWiFi() {
  byte iNetwork = 1;
	uint8_t connectionStatus;
  IPAddress dns(8, 8, 8, 8); 												// Google DNS
  WiFi.disconnect();
  WiFi.mode(WIFI_STA); 															// switch off AP
  WiFi.setAutoConnect(true);
  WiFi.setAutoReconnect(true);
				
	while ( WiFi.status() != WL_CONNECTED && (iNetwork <= NetworksNumber) ) {
			//	Serial.printf ("\nTesting network number %d \n", iNetwork - 1);
    unsigned long start = millis();
    Serial.printf("Connecting to %s ", ssid[iNetwork - 1]);
    WiFi.begin(ssid[iNetwork - 1], password[iNetwork - 1]);
		while (WiFi.status() != WL_CONNECTED && millis() - start < 10000 ) {			// timeout == 10 sek
      delay(200);
      // Serial.print("."); 
			Serial.print(WiFi.status());
    }
			//	Serial.printf("\nWifi status %d \n", WiFi.status()); // 3 WL_CONNECTED, 4 WL_CONNECT_FAILED 6 WL_DISCONNECTING
		if (WiFi.status() != WL_CONNECTED) {
			iNetwork++;
			Serial.printf("\nnetwork %d ", iNetwork);		// 1 WL_NO_SSID_AVAIL 0 WiFi.begin() is called 5 WL_CONNECTION_LOST
			if (iNetwork > NetworksNumber) connectionStatus == WL_CONNECT_FAILED; // No network found
			delay(500);
		}
  }
	connectionStatus = WiFi.status();	
			
  if (connectionStatus == WL_CONNECTED) {
    wifi_signal = WiFi.RSSI(); 														// Get Wifi Signal strength now.
    Serial.print(" WiFi connected at: " + WiFi.localIP().toString());
		wifiBrak = 0;
  }
  else {
		Serial.println(" WiFi connection *** FAILED ***");
		wifiBrak = 1;
	}	
  return connectionStatus;
}
		
	//	--------------
void StopWiFi() {
  WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF);
	Serial.println(" WiFi OFF");
	wifiBrak = 1;
}	
			
	// -----------------
void SetupTime() {
		
 #ifdef ARDUINO_ARCH_ESP32
			// ESP32 seems to be a little more complex:
		configTime(0, 0, ntpServer, ntpServer1);					// 0, 0 because we will use TZ in the next line
		setenv("TZ", Timezone, 1); 												// Set environment variable with your time zone
		tzset();
		delay(500);
		#else
			// ESP8266
		configTime(Timezone, ntpServer); 									// --> for the ESP8266 only
		#endif
 	printLocalTime();  																	// [435]
}
		
	// ----------------------	
void printLocalTime()
{
	time(&now); 																				// read the current time
	localtime_r(&now, &tm); 														// update the structure tm with the current time
	struct tm timeinfo;
	while(!getLocalTime (&timeinfo, 5000) ) {
		return;
	}
				//setTime(2022,10,23, 19,58,55,1);                     // [1830] 23.10.2022 19:05...DST ==1 czas letni ###
					
		//	Serial.print(" _447_");	
	  //  Serial.println(&tm, "%A, %B %d %Y %H:%M:%S");
			
		// Serial.printf("now %d ", now);	
		//Serial.print(timeinfo.tm_wday);									// 0 ..6
		//Serial.print(timeinfo.tm_mday);									// 1 .. 31
		//Serial.println(timeinfo.tm_mon);									// 0 ..11
}    
        
 	//	----- codeForLEDtask is the only task running on core 0 ---------
void codeForLEDtask( void * parameter)
{
  int currentAnimationState;
	unsigned long opoznienie = 0;
	static unsigned long sek10 = 0;
  
	RgbColor color;
			
  for(;;){										// ------ loop for core 0 -----------
				
    if (night || nightOFF)
    {
      stateRGB = 2;  
      animationState = 1;
    }
		switch (stateRGB) {
			case 2:																			//Connected
					//	Serial.println("_475_ case 2");
					//	animationState = 2;																			// ###
        currentAnimationState = animationState;
				switch (animationState) {
					case 0:
						AnimSwitch();																						// min 2 led, sek 4 led
						animations.StartAnimation(6,10,    HourHand0);
						animations.StartAnimation(5,10,    MinuteHand0);
						animations.StartAnimation(4,25,    SecondHand0Tail);			// kasuje ciagle sekundy do 5 leda.
						animations.StartAnimation(3,10,    SecondHand0);					// sekundy led za ledem on
						animations.StartAnimation(7,10,    QuarterMarks);
						animations.StartAnimation(2,10,    FiveMinuteMarks);
						animations.StartAnimation(1,10,    Pendanttail);				// kasuje ledy z tyłu wahadla
						animations.StartAnimation(0,1000,  Pendant);						// wahadlo 60 sek
          break;
					case 1:
						AnimSwitch();																						// wahadlo min 1 led, sek 1 led
						animations.StartAnimation(10,10,   HourHand1);          // [1088]
						animations.StartAnimation(9,10,    MinuteHand1);        // []
						animations.StartAnimation(8,10,    SecondHand1);
						animations.StartAnimation(7,10,    QuarterMarks);
						animations.StartAnimation(2,10,    FiveMinuteMarks);
						animations.StartAnimation(1,10,    Pendanttail);
						animations.StartAnimation(0,1000,  Pendant);
								
          break;
					case 2:
						AnimSwitch();																						// skaczace sekundy
						animations.StartAnimation(10,10,   HourHand2);
						animations.StartAnimation(9,10,    MinuteHand2);
						animations.StartAnimation(8,1000,  SecondHand2);
						animations.StartAnimation(7,10,    QuarterMarks);
						animations.StartAnimation(2,10,    FiveMinuteMarks);
						animations.StartAnimation(1,10,    Pendanttail);
						animations.StartAnimation(0,1000,  Pendant);
          break;
					case 3:
						AnimSwitch();																					// zegar liniowy
						animations.StartAnimation(10,10,   HourHand3);
						animations.StartAnimation(9,10,    MinuteHand3);
						animations.StartAnimation(8,10,    SecondHand3);
						animations.StartAnimation(7,10,    QuarterMarks);
						animations.StartAnimation(2,10,    FiveMinuteMarks);
						animations.StartAnimation(1,10,    Pendanttail);
						animations.StartAnimation(0,1000,  Pendant);						// wahadlo
          break;
					case 4:
						AnimSwitch();																						// wahadlo + liniowy zegar
						animations.StartAnimation(10,1000, HourHand4);
						animations.StartAnimation(9,1000,  MinuteHand4);
						animations.StartAnimation(8,1000,  SecondHand4);
						animations.StartAnimation(7,10,    QuarterMarks);
						animations.StartAnimation(2,10,    FiveMinuteMarks);
						animations.StartAnimation(1,10,    Pendanttail);
						animations.StartAnimation(0,1000,  Pendant);
          break;
					case 5:
						AnimSwitch();																						// liniowy na 60 led
						animations.StartAnimation(10,10,   HourHand5);
						animations.StartAnimation(9,10,    MinuteHand5);
						animations.StartAnimation(8,10,    SecondHand5);
						animations.StartAnimation(7,10,    QuarterMarks);
						animations.StartAnimation(2,10,    FiveMinuteMarks);
						animations.StartAnimation(1,10,    Pendanttail);
						animations.StartAnimation(0,1000,  Pendant);
          break;
					case 6:
						AnimSwitch();																						// liniowy 60 led
						animations.StartAnimation(10,1000, HourHand6);
						animations.StartAnimation(9,1000,  MinuteHand6);
						animations.StartAnimation(8,1000,  SecondHand6);
						animations.StartAnimation(7,10,    QuarterMarks);
						animations.StartAnimation(2,10,    FiveMinuteMarks);
						animations.StartAnimation(1,10,    Pendanttail);
						animations.StartAnimation(0,1000,  Pendant);
          break;
					case 7:
						AnimSwitch();																						// mrowki
						animations.StartAnimation(10,1000, HourHand7);					// [1180]	wyswietla diode godzin	
						animations.StartAnimation(9,1000,  MinuteHand7);				// [1339] wyswietla diode minut
						animations.StartAnimation(8,1000,  SecondHand7);				// [1541] wyswietla diode sekundg
						animations.StartAnimation(4,5,     AllTails);						// [1585] ogon
						animations.StartAnimation(7,10,    QuarterMarks);				// [1624] marker 15 minut
						animations.StartAnimation(2,10,    FiveMinuteMarks);		// [1655]	obecnie wylaczony
						animations.StartAnimation(1,10,    Pendanttail);				// [1702] ogon == Tail
						animations.StartAnimation(0,1000,  Pendant);						// [1679] wahadlo
          break;
					case 8:
						AnimSwitch();																						// animacja ?
						animations.StartAnimation(10,1000, HourHand8);					// []
						animations.StartAnimation(9,1000,  MinuteHand8);				// []
						animations.StartAnimation(8,1000,  SecondHand8);				// []
						animations.StartAnimation(4,5,     AllTails);						// [1585] ogon
						animations.StartAnimation(7,10,    QuarterMarks);				// [1624] marker 15 minut
						animations.StartAnimation(2,10,    FiveMinuteMarks);		// [1655] obecnie wylaczany
						animations.StartAnimation(1,10,    Pendanttail);				// [1702] ogon
						animations.StartAnimation(0,1000,  Pendant);						// [1679]
          break;
					default:
						animationState = 1;
				}	// ---------- switch-animationState -----------
				while((stateRGB == 2) && currentAnimationState == animationState)
				{
					animations.UpdateAnimations();				// 			
					BlendArrays();												// [791] 
					//  stateLED();
					strip.Show();													// 
				}		
      break;
			case 1:																		// NeoPixelCylon
					// Serial.println("_586 case 1");	
				if (demo1) {														// funkcja setup 
					opoznienie = millis() + 1;
					demo1 = 0;		
				}	
				if ( millis() < opoznienie )  
				{	
					SetupAnimations();										// [996]
				}
				if ( millis() - sek10 > 90000 ) 
        {
          demo1 = 1;
          AnimSwitch();
          sek10 = millis();
        } 		
				animations.UpdateAnimations();
				strip.Show();
				delay(15);															// Warning nie ma być ###
			break;
			case 0:																		// snake 
					//	Serial.println("_604 case 0");	
					//	Serial.println(demo1);	
					if (demo1) {													// funkcja setup
          opoznienie = millis() + 1;
          demo1 = 0;    
        } 
        if ( millis() < opoznienie )  
        { 			
          DrawTailPixels();													// [886]
				    // we use the index 0 animation to time how often we move to the next
            // pixel in the strip
					animations.StartAnimation(0, 66, LoopAnimUpdate); // org 12, 66
        }
				if ( millis() - sek10 > 9000 ) 
				{
					demo1 = 1;
					AnimSwitch();
					sek10 = millis();
				}	
				animations.UpdateAnimations();
				strip.Show();
       	delay(15);																	// warning ma być >= 15 msek ###
									
			break;
			case 3:
						  //  Serial.println("_630 case 3");
        for (int i = 0; i <= 59; i++){
					strip.SetPixelColor(i, RgbColor (0,255,0));              // green
					strip.Show();
          delay(16);			
          if( stateRGB != 3){break;}
        }
        for (int i=0; i <= 59; i++){
          strip.SetPixelColor(i, RgbColor (0,0,0));       					
					strip.Show();
          delay(16);
          if( stateRGB != 3){break;}
        }
      break;
			case 4:
						//  Serial.println("_646 case 4");
        for (int i = 0; i <= 59; i++){
					strip.SetPixelColor(i, RgbColor (0,0,255) );      				// blue
					strip.Show();
          delay(16);
          if( stateRGB != 4){break;}
        }
        for (int i=0; i <= 59; i++){
          strip.SetPixelColor(i, RgbColor (0,0,0));
					strip.Show();
          delay(16);
          if( stateRGB != 4){break;}
        }
			break;
			default:		
				stateRGB = 0;
		}	// -------- switch-stateRGB ------------------------------
  }	// ------------- end-for(;;) -------------------------------
}	// ------------------- end-codeForLEDtask -------------------
			
	// ------------------------------------------------ 
void CheckAutoDim(void){
			
  if(dimOn)
  {
     
    if( (hourDirectCalc > hourStartDim) && hourDirectCalc <= (hourStartDim + 1) || (hourDirectCalc > 04) && hourDirectCalc < hourStopDim ) {		// 20 .. 21, 05 .. 06
		  nightOFF = 1;	
			valueDim = 0;
			pendantColor.R = 0;                                 // wahadlo zgas 
			pendantColor.G = 0;
			pendantColor.B = 0;
      secondHandColor.R = 0;                              // sekundy zgas
      secondHandColor.G = 0;
      secondHandColor.B = 0;
			totalBrightness = 0;                                 // off RGB
      stanMP3 = 1;																					// pause ?
      podajCzas = 0;                                        // blokada podawania czasu
			  // Serial.printf("_680_ nightOFF %d \n", nightOFF);
    } else {
			nightOFF = 0;
		}
				
		if((hourDirectCalc > hourStartDim + 1) || (hourDirectCalc < 05)) {		// noc wylacz OLED
			night = 1;
			valueDim = 0;
			pendantColor.R = 0;                                  // wahadlo zgas 
			pendantColor.G = 0;
			pendantColor.B = 0;
      secondHandColor.R = 0;                              // sekundy zgas
      secondHandColor.G = 0;
      secondHandColor.B = 0;
			totalBrightness = 0;                                 // off RGB
			stanMP3 = 1;																				 // pause ?
      podajCzas = 0;                                      // blokada podawania czasu
			  // Serial.printf("_700_ night %d \n", night);
		} else {
			night = 0;
		}		
				
		if ( night == 0 && nightOFF == 0) {											// dzien
			if (valueDim < 1) valueDim = 1;
			dimBrightness = valueDim;															// 55
			if (wahadlo == 1) {
				pendantColor.R = 95;																// ###
				pendantColor.G = 160;																// ###
				pendantColor.B = 50;																// ###
			} else {
				pendantColor.R = 0;
				pendantColor.G = 0;
				pendantColor.B = 0;
			}
				//	totalBrightness = temp;                                // on RGB
			totalBrightness = valueDim;                            // on RGB
			secondHandColor.R = 0;                              	 // sekundy zapal
      secondHandColor.G = 0;
      secondHandColor.B = 255;
    }
				
	}
  else{
    night = 0; 
		dimBrightness = 155;
  }
}
				
	// ------------------------------------
void CheckAlarm(void){  
  if(alarmOn )									// w nocy blokuj statusy i alarmy
  {
			//	Serial.print(hourDirectCalc); Serial.print("-"); Serial.println(minDirectCalc); 
			//	Serial.print(hourAlarm); Serial.print("-"); Serial.println(minAlarm);
		if (minCalc%2 == 0 )		
			//	if((hourDirectCalc == hourAlarm) && (minCalc == minAlarm) && (secCalc == 0))
			//	if((hourDirectCalc == hourAlarm) && (minDirectCalc == minAlarm) && (secDirectCalc > 0))
		{
				
			durationAlarm = DURATIONALARM;
			animations.StartAnimation(11,1000,AlarmAnimation);
			DEBUG_PRINTLN("");
			DEBUG_PRINTLN("Alarm triggered");
			DEBUG_PRINTLN("");
		}
  }
}
			
	// -------- Should be called when you switch between main animations ----------
void AnimSwitch(void){
  animations.StopAll();
  ClearArrays();																		// [776]
  ProcessTime();
}
			

	// --- It will end the task on the seperate core -------------
void RestartDevice(){
    vTaskDelete(LEDtask);
    delay(100);
    WiFi.softAPdisconnect();
    delay(100);
    ESP.restart();
}
					
	// -------  ClearArrays will clear all animation arrays ----
void ClearArrays(void){
  RgbColor color = (0,0,0);
  for (int i=0; i < (PixelCount); i++){
    animationArray1[i] = color;
    animationArray2[i] = color;
    animationArray3[i] = color;
    animationArray4[i] = color;
    animationArray5[i] = color;
    animationArray6[i] = color;
    animationArray7[i] = color;
		strip.SetPixelColor(i, color);
  }
}
			
	// -------------------------------------------------
void BlendArrays(void){
  RgbColor color;
		//	int blendBrightness = map(totalBrightness, 0, 255, 0, maxBrightness);		// 15, (0, 255) --> 0--255 
	int blendBrightness = map(totalBrightness, 0, 255, 0, 155);							// 15, (0, 255) --> 0--255 
		//	blendBrightness = map(blendBrightness, 0, 255, 0, dimBrightness);				// bland(0, 255) --> 0--155
	blendBrightness = map(blendBrightness, 0, 255, 0, maxBrightness);				// bland(0, 255) --> 0--155
					
	for (int i = 0; i < (PixelCount); i++){
				
    color = AddColors(RgbColor(0,0,0),animationArray1[i]);
    color = AddColors(color,animationArray2[i]);
    color = AddColors(color,animationArray3[i]);
    color = AddColors(color,animationArray4[i]);
    color = AddColors(color,animationArray5[i]);
    color = AddColors(color,animationArray6[i]);
    color = AddColors(color,animationArray7[i]);
						
    if (invert == 1){
      color.R = 255-color.R;
      color.G = 255-color.G;
      color.B = 255-color.B;
    }
					
    color = colorGamma.Correct(color);
		color = AdjustBrightness(color, blendBrightness);													// [810]	
    strip.SetPixelColor(i, color);
  }
}
				
	// ------------------------------------------------------
RgbColor AdjustBrightness(RgbColor color, int brightness){
				
  color.R = map(color.R, 0, 255, 0, brightness);															// 
  color.G = map(color.G, 0, 255, 0, brightness);
  color.B = map(color.B, 0, 255, 0, brightness);
		//	if (millis()%3000 == 0) Serial.printf("_824_ %d \t", brightness);
  return color;
}
			
	// -----------------------------------------------------
RgbColor AddColors(RgbColor color1, RgbColor color2){
  int _newR = color1.R + color2.R;
  int _newG = color1.G + color2.G;
  int _newB = color1.B + color2.B;
						
  uint8_t newR = (_newR > 255) ? 255 : _newR;
  uint8_t newG = (_newG > 255) ? 255 : _newG;
  uint8_t newB = (_newB > 255) ? 255 : _newB;
					
  return RgbColor(newR, newG, newB);
}
				
	// ----------------------------------------------------
void ProcessTime(void ){
		
  hourCalc = HourCalc();
	minCalc = tm.tm_min;				// ###
	secCalc = tm.tm_sec;				// ###
}
		
	// --------------------------------------------------
int HourCalc(void ){
  int hourTemp;
  			
  hourTemp = tm.tm_hour;
  hourDirectCalc = hourTemp;
  			
  if (hourTemp < 12){
    hourTemp  = hourTemp * 5;
  }
  else{
    hourTemp  = hourTemp - 12;
		hourTemp  = hourTemp * 5;				
	}
				
  return hourTemp;
}
				
	// -------------------------------------------------
void AlarmAnimation(const AnimationParam& param){
  float progress = animation1(param.progress);
					
	for (int i = 0; i < PixelCount; i++){
	  animationArray7[i] = RgbColor (0,0,0);
  }
				
	for (int i = poczAlarm; i < (AlarmCount + poczAlarm ); i++){
	  animationArray7[i] = RgbColor::LinearBlend(RgbColor(255,0,0), RgbColor(0,0,0), progress);
  } 
			
  if (param.state == AnimationState_Completed)
  {
    if (durationAlarm > 0){
      durationAlarm--;
      animations.RestartAnimation(param.index);
    }
    else if (durationAlarm == 0){
      //do nothing;
    }
  }
}
			
	// ------------------------------------------
void LoopAnimUpdate(const AnimationParam& param)
{
	  // wait for this animation to complete,
    // we are using it as a timer of sorts
  if (param.state == AnimationState_Completed)
  {
      // done, time to restart this position tracking animation/timer
    animations.RestartAnimation(param.index);
					
      // rotate the complete strip one pixel to the right on every update
      // strip.RotateLeft(2);           // max <=50
      strip.RotateRight(1);
  }
}
			
	// --------------------
void DrawTailPixels()
{
    // using Hsl as it makes it easy to pick from similiar saturated colors
  float hue = random(360) / 360.0f;
  for (uint16_t index = 0; index < strip.PixelCount() && index <= TailLength; index++)
  {
    float lightness = index * MaxLightness / TailLength;
	  RgbColor color = HslColor(hue, 1.0f, lightness);      // org 1.0f
					
    strip.SetPixelColor(index, colorGamma.Correct(color));
  }
}			
			
	// --------------------------		
void FadeAll(uint8_t darkenBy)
{
    RgbColor color;
    for (uint16_t indexPixel = 0; indexPixel < strip.PixelCount(); indexPixel++)
    {
        color = strip.GetPixelColor(indexPixel);
        color.Darken(darkenBy);
        strip.SetPixelColor(indexPixel, color);
    }
}
			
	// --------------------------------------------
void FadeAnimUpdate(const AnimationParam& param)
{
    if (param.state == AnimationState_Completed)
    {
        FadeAll(10);																						// [916]
        animations.RestartAnimation(param.index);
    }
}
	
	// ------------------------------------------------
void FadeOutAnimUpdate(const AnimationParam& param)
{																																// for NeoPixelFunLoop
				// this gets called for each animation on every time step
				// progress will start at 0.0 and end at 1.0
				// we use the blend function on the RgbColor to mix
				// color based on the progress given to us in the animation
				
    RgbColor updatedColor = RgbColor::LinearBlend(
        animationStateFun[param.index].StartingColor,
        animationStateFun[param.index].EndingColor,
        param.progress);
    strip.SetPixelColor(animationStateFun[param.index].IndexPixel, 
        colorGamma.Correct(updatedColor));												// apply the color to the strip
}
			
	// -------------------------------------------
void LoopAnimUpdateFun(const AnimationParam& param)
{																																	// for NeoPixelFunLoop
						// wait for this animation to complete,
						// we are using it as a timer of sorts
    if (param.state == AnimationState_Completed)
    {
						// done, time to restart this position tracking animation/timer
        animations.RestartAnimation(param.index);
					
						// pick the next pixel inline to start animating
         
        frontPixel = (frontPixel + 1) % PixelCount; // increment and wrap
			  if (frontPixel == 0)
        {
            // we looped, lets pick a new front color
            frontColor = HslColor(random(360) / 360.0f, 1.0f, 0.25f);
        }
						
        uint16_t indexAnim;
						// do we have an animation available to use to animate the next front pixel?
						// if you see skipping, then either you are going to fast or need to increase
						// the number of animation channels
        if (animations.NextAvailableAnimation(&indexAnim, 1))
        {
            animationStateFun[indexAnim].StartingColor = frontColor;
            animationStateFun[indexAnim].EndingColor = RgbColor(0, 0, 0);
            animationStateFun[indexAnim].IndexPixel = frontPixel;
						animations.StartAnimation(indexAnim, PixelFadeDuration, FadeOutAnimUpdate);
        }
    }
}
			
  // -------------------
void SetupAnimations()
{
    // fade all pixels providing a tail that is longer the faster
    // the pixel moves.
    animations.StartAnimation(0, 15, FadeAnimUpdate);  							// [936] org 5, 15
      
    // take several seconds to move eye fron one side to the other
    animations.StartAnimation(1, 2000, MoveAnimUpdate);  						// [1000] org 1, 2000
}
    
  // ------------------------------------------        
void MoveAnimUpdate(const AnimationParam& param)
{
    // apply the movement animation curve
    float progress = moveEase(param.progress);
			
    // use the curved progress to calculate the pixel to effect
    uint16_t nextPixel;
    if (moveDir > 0)
    {
        nextPixel = progress * PixelCount;
    }
    else
    {
        nextPixel = (1.0f - progress) * PixelCount;
    }
			
    // if progress moves fast enough, we may move more than
    // one pixel, so we update all between the calculated and
    // the last
    if (lastPixel != nextPixel)
    {
        for (uint16_t i = lastPixel + moveDir; i != nextPixel; i += moveDir)
        {
            strip.SetPixelColor(i, CylonEyeColor);
        }
    }
    strip.SetPixelColor(nextPixel, CylonEyeColor);
			
    lastPixel = nextPixel;
			
    if (param.state == AnimationState_Completed)
    {
        // reverse direction of movement
        moveDir *= -1;
			
        // done, time to restart this position tracking animation/timer
        animations.RestartAnimation(param.index);
    }
}
							
	//----------------------------------------------------
void HourHand0(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray5[i] = RgbColor (0,0,0);
  }
  if (HourCalc() == minCalc) {
		if (timeOFF) animationArray5[hourCalc] = hourHandColor;
  }else {
      animationArray5[hourCalc] = hourHandColor;
  }
			
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
		
	//----------------------------------------------------
void HourHand1(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray5[i] = RgbColor (0,0,0);
  }
  if (HourCalc() == minCalc) {
    if (timeOFF) animationArray5[hourCalc] = hourHandColor;
  } else {
    animationArray5[hourCalc] = hourHandColor;
  }
      
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
			
	//----------------------------------------------------
void HourHand2(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray5[i] = RgbColor (0,0,0);
  }
			
  float fade = (float)minCalc / 59.0;
			
  animationArray5[hourCalc] = RgbColor::LinearBlend(hourHandColor, RgbColor(0,0,0), fade);
  animationArray5[circleArray[hourCalc + 1]] = RgbColor::LinearBlend(RgbColor(0,0,0), hourHandColor, fade);
			
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
			
	//----------------------------------------------------
void HourHand3(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray5[i] = RgbColor (0,0,0);
  }
			
  for (int j=0; j <= (hourCalc); j++){
    animationArray5[j] = hourHandColor;
  }
				
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
			
//-----------------------------------------------------
 void HourHand4(const AnimationParam& param){
  float progress = animation4(param.progress);
  float fade = (float)minCalc/59.0;

  for (int j=0; j < (hourCalc); j++){
    if((animationArray5[j].R != hourHandColor.R)||(animationArray5[j].G != hourHandColor.G)||(animationArray5[j].B != hourHandColor.B)){
      animationArray5[j] = RgbColor::LinearBlend(animationArray5[j], hourHandColor, progress);
    }
    else{
      animationArray5[j] = hourHandColor;
    } 
  }
				
  animationArray5[hourCalc] = RgbColor::LinearBlend(RgbColor(0,0,0), hourHandColor, fade); 
				
  for (int i = hourCalc + 1; i < (PixelCount); i++){
    animationArray5[i] = RgbColor(0,0,0);
  }
				
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
				
//-----------------------------------------------------
void HourHand5(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray5[i] = RgbColor (0,0,0);
  }

  for (int j=(hourCalc); j < (PixelCount); j++){
    animationArray5[j] = hourHandColor;
  }
  
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
			
//----------------------------------------------------
void HourHand6(const AnimationParam& param){
  float progress = animation4(param.progress);
  float fade = (float)minCalc/59.0;
 
  for (int j=(hourCalc); j < (PixelCount); j++){
    if((animationArray5[j].R != hourHandColor.R)||(animationArray5[j].G != hourHandColor.G)||(animationArray5[j].B != hourHandColor.B)){
      animationArray5[j] = RgbColor::LinearBlend(animationArray5[j], hourHandColor, progress);
    }
    else{
      animationArray5[j] = hourHandColor;
    } 
  }
				
  animationArray5[hourCalc] = RgbColor::LinearBlend(hourHandColor, RgbColor(0,0,0), fade); 
				
  for (int i=0; i < (hourCalc); i++){
    animationArray5[i] = RgbColor(0,0,0);
  }
				
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
			
//----------------------------------------------------
void HourHand7(const AnimationParam& param){
  float progress = animation5(param.progress);
  
  uint16_t nextPixel;
  
  nextPixel = progress * hourCalc;
  
  animationArray5[circleArray[nextPixel]] = hourHandColor;
    
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
		
//----------------------------------------------------
void HourHand8(const AnimationParam& param){
  float progress = animation5(param.progress);
			
  uint16_t nextPixel;
				
  nextPixel = progress * 60;
			
  nextPixel = nextPixel + hourCalc;
				
  if(nextPixel > 60){
    nextPixel = nextPixel - 60;
  }
			
  if(nextPixel > 60){
    nextPixel = 60;
  }
				
  animationArray5[circleArray[nextPixel]] = hourHandColor;
    
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
				
//----------------------------------------------------
void MinuteHand0(const AnimationParam& param){
  int minTemp;

  RgbColor minuteHandColor1 = RgbColor::LinearBlend(minuteHandColor, RgbColor(0,0,0), 0.3f);
  RgbColor minuteHandColor2 = RgbColor::LinearBlend(minuteHandColor, RgbColor(0,0,0), 0.6f);
  RgbColor minuteHandColor3 = RgbColor::LinearBlend(minuteHandColor, RgbColor(0,0,0), 0.75f);
  
  for (int i=0; i < (PixelCount); i++){
    animationArray4[i] = RgbColor (0,0,0);
  }
				
  minTemp = minCalc;
				
  animationArray4[minCalc] = minuteHandColor;
				
  if(minCalc == 0){
    minTemp = 60;
    animationArray4[(minTemp - 1)] = minuteHandColor1;
    animationArray4[(minTemp - 2)] = minuteHandColor2;
    animationArray4[(minTemp - 3)] = minuteHandColor3;
  }
  else if(minCalc == 1){
    animationArray4[(minTemp - 1)] = minuteHandColor1;
    minTemp = 61;
    animationArray4[(minTemp - 2)] = minuteHandColor2;
    animationArray4[(minTemp - 3)] = minuteHandColor3;
  }
  else if(minCalc == 2){
    animationArray4[(minTemp - 1)] = minuteHandColor1;
    animationArray4[(minTemp - 2)] = minuteHandColor2;
    minTemp = 62;
    animationArray4[(minTemp - 3)] = minuteHandColor3;
  }
  else{
    animationArray4[(minTemp - 1)] = minuteHandColor1;
    animationArray4[(minTemp - 2)] = minuteHandColor2;
    animationArray4[(minTemp - 3)] = minuteHandColor3;
  }
				
  if (param.state == AnimationState_Completed)
    {
      animations.RestartAnimation(param.index);
    }
}
			
//----------------------------------------------------
void MinuteHand1(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray4[i] = RgbColor (0,0,0);
  }
  
  animationArray4[minCalc] = minuteHandColor;

  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
				
//----------------------------------------------------
void MinuteHand2(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray4[i] = RgbColor (0,0,0);
  }

  float fade = (float)secCalc / 59.0;

  animationArray4[minCalc] = RgbColor::LinearBlend(minuteHandColor, RgbColor(0,0,0), fade);
  animationArray4[circleArray[minCalc+1]] = RgbColor::LinearBlend(RgbColor(0,0,0), minuteHandColor, fade);


  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
//----------------------------------------------------
void MinuteHand3(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray4[i] = RgbColor (0,0,0);
  }

  for (int j=0; j <= (minCalc); j++){
    animationArray4[j] = minuteHandColor;
  }
  
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
//----------------------------------------------------
void MinuteHand4(const AnimationParam& param){
  float progress = animation4(param.progress);
  float fade = (float)secCalc/59.0;

  for (int j=0; j < (minCalc); j++){
    if((animationArray4[j].R != minuteHandColor.R)||(animationArray4[j].G != minuteHandColor.G)||(animationArray4[j].B != minuteHandColor.B)){
      animationArray4[j] = RgbColor::LinearBlend(animationArray4[j], minuteHandColor, progress);
    }
    else{
      animationArray4[j] = minuteHandColor;
    } 
  }
  
  animationArray4[minCalc] = RgbColor::LinearBlend(RgbColor(0,0,0), minuteHandColor, fade); 

  for (int i= minCalc+1; i < (PixelCount); i++){
    animationArray4[i] = RgbColor(0,0,0);
  }
  
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
//----------------------------------------------------
void MinuteHand5(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray4[i] = RgbColor (0,0,0);
  }

  for (int j=(minCalc); j < (PixelCount); j++){
    animationArray4[j] = minuteHandColor;
  }
  
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
//-----------------------------------------------------
void MinuteHand6(const AnimationParam& param){
  float progress = animation4(param.progress);
  float fade = (float)secCalc/59.0;
 
  for (int j=(minCalc); j < (PixelCount); j++){
    if((animationArray4[j].R != minuteHandColor.R)||(animationArray4[j].G != minuteHandColor.G)||(animationArray4[j].B != minuteHandColor.B)){
      animationArray4[j] = RgbColor::LinearBlend(animationArray4[j], minuteHandColor, progress);
    }
    else{
      animationArray4[j] = minuteHandColor;
    } 
  }
  
  animationArray4[minCalc] = RgbColor::LinearBlend(minuteHandColor, RgbColor(0,0,0), fade); 
  
  for (int i=0; i < (minCalc); i++){
    animationArray4[i] = RgbColor(0,0,0);
  }
  
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
//----------------------------------------------------
void MinuteHand7(const AnimationParam& param){
  float progress = animation5(param.progress);
  
  uint16_t nextPixel;
  
  nextPixel = progress * minCalc;
  
  animationArray4[circleArray[nextPixel]] = minuteHandColor;
    
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
//-----------------------------------------------------
void MinuteHand8(const AnimationParam& param){
  float progress = animation5(param.progress);
  
  uint16_t nextPixel;
  
  nextPixel = progress * 60;

  nextPixel = nextPixel + minCalc;

  if(nextPixel > 60){
    nextPixel = nextPixel - 60;
  }

  if(nextPixel > 60){
    nextPixel = 60;
  }
  
  animationArray4[circleArray[nextPixel]] = minuteHandColor;
    
  if (param.state == AnimationState_Completed)
  {
    animations.RestartAnimation(param.index);
  }
}
//-------------------------------------------------------------------------------
void SecondHand0(const AnimationParam& param){
  animationArray3[secCalc] = secondHandColor;

  if (param.state == AnimationState_Completed)
    {
      ProcessTime();
      animations.RestartAnimation(param.index);
    }
}
//-------------------------------------------------------------------------------
void SecondHand1(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray3[i] = RgbColor (0,0,0);
  }
  
  animationArray3[secCalc] = secondHandColor;
  
  if (param.state == AnimationState_Completed)
  {
    ProcessTime();
    animations.RestartAnimation(param.index);
  }
}
//-------------------------------------------------------------------------------
void SecondHand2(const AnimationParam& param){
  float progress = animation4(param.progress);
  for (int i=0; i < (PixelCount); i++){
    animationArray3[i] = RgbColor (0,0,0);
  }
   
  animationArray3[secCalc] = RgbColor::LinearBlend(secondHandColor, RgbColor(0,0,0), progress);
  animationArray3[circleArray[secCalc+1]] = RgbColor::LinearBlend(RgbColor(0,0,0), secondHandColor, progress);
  
  if (param.state == AnimationState_Completed)
  {
    ProcessTime();
    animations.RestartAnimation(param.index);
  }
}
//-------------------------------------------------------------------------------
void SecondHand3(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray3[i] = RgbColor (0,0,0);
  }
  
  for (int j=0; j <= (secCalc); j++){
    animationArray3[j] = secondHandColor;
  }
  
  if (param.state == AnimationState_Completed)
  {
    ProcessTime();
    animations.RestartAnimation(param.index);
  }
}
//-------------------------------------------------------------------------------
void SecondHand4(const AnimationParam& param){
  float progress = animation4(param.progress);
 
  for (int j=0; j < (secCalc); j++){
    if((animationArray3[j].R != secondHandColor.R)||(animationArray3[j].G != secondHandColor.G)||(animationArray3[j].B != secondHandColor.B)){
      animationArray3[j] = RgbColor::LinearBlend(animationArray3[j], secondHandColor, progress);
    }
    else{
      animationArray3[j] = secondHandColor;
    } 
  }
  
  animationArray3[secCalc] = RgbColor::LinearBlend(RgbColor(0,0,0), secondHandColor, progress); 
  
  for (int i= secCalc+1; i < (PixelCount); i++){
    animationArray3[i] = RgbColor(0,0,0);
  }
  
  if (param.state == AnimationState_Completed)
  {
    ProcessTime();
    animations.RestartAnimation(param.index);
  }
}
//-------------------------------------------------------------------------------
void SecondHand5(const AnimationParam& param){
  for (int i=0; i < (PixelCount); i++){
    animationArray3[i] = RgbColor (0,0,0);
  }

  for (int j=(secCalc); j < (PixelCount); j++){
    animationArray3[j] = secondHandColor;
  }
  
  if (param.state == AnimationState_Completed)
  {
    ProcessTime();
    animations.RestartAnimation(param.index);
  }
}
//-------------------------------------------------------------------------------
void SecondHand6(const AnimationParam& param){
  float progress = animation4(param.progress);
 
  for (int j=(secCalc); j < (PixelCount); j++){
    if((animationArray3[j].R != secondHandColor.R)||(animationArray3[j].G != secondHandColor.G)||(animationArray3[j].B != secondHandColor.B)){
      animationArray3[j] = RgbColor::LinearBlend(animationArray3[j], secondHandColor, progress);
    }
    else{
      animationArray3[j] = secondHandColor;
    } 
  }
  
  animationArray3[secCalc] = RgbColor::LinearBlend(secondHandColor, RgbColor(0,0,0), progress); 
  
  for (int i=0; i < (secCalc); i++){
    animationArray3[i] = RgbColor(0,0,0);
  }
  
  if (param.state == AnimationState_Completed)
  {
    ProcessTime();
    animations.RestartAnimation(param.index);
  }
}
//------------------------------------------------
void SecondHand7(const AnimationParam& param){
  float progress = animation5(param.progress);									// NeoEase::QuadraticIn
  
  uint16_t nextPixel;
  
  nextPixel = progress * secCalc;
  
  animationArray3[circleArray[nextPixel]] = secondHandColor;		// 	Array3 -> second array, circleArray -> tablica karuzeli 0..61	
    
  if (param.state == AnimationState_Completed)
  {
    ProcessTime();
    animations.RestartAnimation(param.index);
  }
}

	// ------------------------------------------------
void SecondHand8(const AnimationParam& param){
  float progress = animation5(param.progress);
  
  uint16_t nextPixel;
  
  nextPixel = progress * 60;

  nextPixel = nextPixel + secCalc;

  if(nextPixel > 60){
    nextPixel = nextPixel - 60;
  }

  if(nextPixel > 60){
    nextPixel = 60;
  }
  
  animationArray3[circleArray[nextPixel]] = secondHandColor;
    
  if (param.state == AnimationState_Completed)
  {
    ProcessTime();
    animations.RestartAnimation(param.index);
  }
}
				
	// --------------------------------------------
void AllTails(const AnimationParam& param){
  if (param.state == AnimationState_Completed)
    {
      RgbColor color;
        for (uint16_t indexPixel = 0; indexPixel <= 59; indexPixel++)
        {
            color = animationArray3[indexPixel];
            color.Darken(2);
            animationArray3[indexPixel] = color;
            color = animationArray4[indexPixel];
            color.Darken(2);
            animationArray4[indexPixel] = color;
            color = animationArray5[indexPixel];
            color.Darken(2);
            animationArray5[indexPixel] = color;
        }
            animations.RestartAnimation(param.index);
    }
}
			
	// ---------------------------------------------------
void SecondHand0Tail(const AnimationParam& param){
  if (param.state == AnimationState_Completed)
    {
      RgbColor color;
        for (uint16_t indexPixel = 0; indexPixel <= 59; indexPixel++)
        {
            color = animationArray3[circleArray[indexPixel]];
            
            color.Darken(secondHandTail);
							
            animationArray3[indexPixel] = color;
            
        }
            animations.RestartAnimation(param.index);
    }
}
				
	// --------------------------------------------------------
void QuarterMarks(const AnimationParam& param){
  float progress = animation3(param.progress);						// 0, 002, 005, 018
  bool fadeDir2 = 0;
	RgbColor quarterColor;		
	int temp;		
			
  if(fadeDir2){										
    quarterColor = RgbColor::LinearBlend(quarterColor1, quarterColor2, progress);
  }
  else														
  {
    quarterColor = RgbColor::LinearBlend(quarterColor2, quarterColor1, progress);
  }
			
	for (int i=0; i < (PixelCount/15); i++){  // org 15
		temp = HourCalc();
		if (temp == quarterNumbers[i] || minCalc == quarterNumbers[i] ) {
			animationArray6[quarterNumbers[i]] = RgbColor (0,0,0);		// 0,15,30,45
		} else {
			animationArray6[quarterNumbers[i]] = quarterColor;				// 0,15,30,45
		}
  }
				
  if (param.state == AnimationState_Completed)
    {
      animations.RestartAnimation(param.index);
      fadeDir2 = !fadeDir2;  			
    }
}
				
	// --------------------------------------------------------
void FiveMinuteMarks(const AnimationParam& param){
  float progress = animation2(param.progress);
  /*RgbColor fiveMinuteColor;
				
  if(fadeDir){
    fiveMinuteColor = RgbColor::LinearBlend(fiveMinuteColor2, fiveMinuteColor1, progress);
  }
  else
  {
    fiveMinuteColor = RgbColor::LinearBlend(fiveMinuteColor1, fiveMinuteColor2, progress);
  }*/
				
  for (int i=0; i < (PixelCount/5); i++){   
    animationArray2[fiveMinuteNumbers[i]] = fiveMinuteColor;
  }

  if (param.state == AnimationState_Completed)
    {
      animations.RestartAnimation(param.index);
      //fadeDir = !fadeDir;  
    }
}
		
	// -------------------------------------------------
void Pendant(const AnimationParam& param){
  float progress = animation1(param.progress);
				
  uint16_t nextPixel;
					
  if (pendantDir){
    nextPixel = progress * 60;		// org 60
  }
  else{
    nextPixel = progress * 60;		// org 60
    nextPixel = 60 - nextPixel;		// org 60
  }
				
  animationArray1[circleArray[nextPixel]] = pendantColor;
    
  if (param.state == AnimationState_Completed)
    {
      animations.RestartAnimation(param.index);
      pendantDir = !pendantDir;   
    }
}
		
	//	---------------------------------------------------
void Pendanttail(const AnimationParam& param){
  if (param.state == AnimationState_Completed)
    {
      RgbColor color;
        for (uint16_t indexPixel = 0; indexPixel <= 59; indexPixel++)		// org 59
        {
            color = animationArray1[circleArray[indexPixel]];
            
            color.Darken(pendantTail);
            animationArray1[indexPixel] = color;
            
        }
            animations.RestartAnimation(param.index);
    }
}
		
	// -----------------------------------------------------------
void displayTemperature() {
			
  String myString = ""; 
  static bool pierwszy = 1;  
  static float humidity;
  static float pressure;
  static float temperature;  
			
	if( secCalc%10 == 0 || pierwszy) {	
		humidity = climateSensor.getRelativeHumidity();
		pressure = climateSensor.getPressure();
		temperature = climateSensor.getTemperatureCelcius(true);
    pierwszy = 0;
		/*			
		Serial.print("\tTemperatura = ");
		Serial.print(temperature);
		Serial.print(", Humidity: ");
		Serial.print(humidity);
		Serial.print(" and Pressure: ");
		Serial.println(pressure);
    */
	}
	myString.concat(humidity);
	u8g2.setCursor(1, 48);                                // 3 line
  u8g2.print(myString);
  u8g2.drawStr(45, 48, "%");
  				
	myString = ""; 			
	
	myString.concat(pressure);
	u8g2.setCursor(1, 32);                                // 2 line
  u8g2.print(myString);
                
	myString = ""; 						
					
  myString.concat(temperature);
	u8g2.setCursor(70, 32);
  u8g2.print(myString);
	u8g2.setCursor(110, 32);
  u8g2.print( (char)176 );                      				// 176 st C
  u8g2.drawStr(118, 32, "C");
}
			
	// ---------------			
int godzina(){
	int ki;
	ki = tm.tm_hour;
		return ki;
}
			
	// ---------------			
int minuta(){
	int ki;
	ki = tm.tm_min;
		return ki;
}
	
	// ---------------			
int sekunda(){
	int ki;
	ki = tm.tm_sec;
		return ki;
}

  // ----------------
void stateLED(void) {
  static int j = 5; 
  static bool asd = 1;
  for (int k = 5; k < j ; k++) {
    strip.SetPixelColor(k, RgbColor (105,2,106));
  } 
  if (!secCalc && asd == 1) {
    ++j;
    asd = 0;
    if (j> 9) {
      j = 5;
      asd = 0;
    } 
  } 
  if (secCalc == 1) asd =1;   
}
		
	// -----------------------------------------------------------------------------
void setTime(int yr, int month, int mday, int hr, int minute, int sec, int isDst){
  struct tm tm;
				                              // dziala tylko przez USB !!
  tm.tm_year = yr - 1900;   					// Set date
  tm.tm_mon = month-1;
  tm.tm_mday = mday;
  tm.tm_hour = hr;      							// Set time
  tm.tm_min = minute;
  tm.tm_sec = sec;
  tm.tm_isdst = isDst;  							// 1 or 0
  time_t t = mktime(&tm);
  Serial.printf("Setting time: %s", asctime(&tm));
  struct timeval now = { .tv_sec = t };
  settimeofday(&now, NULL);
}
            
	//	------------------------------------------------------ setup ----------------------------------------
void setup(){
       
  Serial.begin(115200);
		
	preferences.begin("my-app", false);
  counter = preferences.getUInt("counter", 0);
  Serial.printf("_1820_ counter value: %u\n", counter);
				
	beginOTA();
	      	
	#ifdef DEBUG
    // Serial.begin(115200);
  #endif 
	esp_bluedroid_disable();
	esp_bluedroid_deinit();
	esp_bt_controller_disable();
	esp_bt_controller_deinit();
	esp_bt_mem_release(ESP_BT_MODE_BTDM);
						
	Serial.println("");	
				// Perform a low level sanity checks that the compiler performs bit field
				// packing as we expect and Endianness is as we expect.
  assert(irutils::lowLevelSanityCheck() == 0);
			
	DEBUG_PRINTLN();
  DEBUG_PRINTLN("Booted..");
  stan = 0;			
  					
	strip.Begin();										        // init RGB LED
  strip.Show();															// black RGB
	SetRandomSeed();	
				
	// Wire.begin(I2C_SDA, I2C_SCL);
	      
	u8g2.begin();
		//	u8g2.noDisplay();
		//	u8g2.setFont(u8g2_font_inb16_mr);		// duzy font 16.	ascii 32 .. 127
		//	u8g2.setFont(u8g2_font_profont22_mf);		  // duzy font 14.	ascii 32 .. 256
	u8g2.setFont(u8g2_font_crox4t_tf);         		// duzy font 13.  ascii 32 .. 256
	u8g2.setFontMode(0);		                  		// enable transparent mode, which is faster
  u8g2.setFlipMode(1);                      		// do gory nogami.
				
	climateSensor.begin();												// init BME280
	Serial.println(F("Climate sensor begin: BME280"));
					
	    // Initialize sensor in continues mode, high 0.5 lx resolution
  sensor.begin(ModeContinuous, ResolutionHigh);	// BH1750 lux		
			
			// Start conversion
  sensor.startConversion();		
		// ------------- init OLED 128 x64 4 row -----------
	Serial.println("Initializing OLED Display, Wi-Fi");
	 	
	u8g2.drawStr(0, 16, "Clock station");       // 13 char max.
  u8g2.drawStr(0, 32, "start Wi-Fi");
  u8g2.drawStr(0, 48, "ver. ");
  u8g2.setCursor(45, 48);
  u8g2.print(version);
				
	u8g2.sendBuffer();
				
	delay(1000);    			
			
												//  starts task that is run on seperate core for the LEDs, 
  xTaskCreatePinnedToCore(				// ------------------ task on core 0 ----------
												codeForLEDtask,          // Task Function 
												"LEDtask",               // Name of task 
												2000,                    // Stack size of task org 1500
												NULL,                    // Parameter of the task 
												1,                       // Priority of the Task org 1
												&LEDtask,                // Task handle
												0);                      // Core
		// ---------------			
				
		//	StartWiFi();																		// [294] start Wi-Fi, wifiBrak = 0
	  	      
  Serial.print("WiFi connected?.");
	Serial.print(" \tWi-Fi status: ");
	Serial.print(WiFi.status());
	Serial.print(" \tRSSI = ");
	Serial.println(wifi_signal);
	  		
  SetupTime();																		// [420] start ntp server, Timezone ntpserver
		
	//	setenv("TZ", Timezone, 1);											// Set environment variable with your time zone
	//	tzset();	
	time_t now = time(NULL);
  struct tm * now_utc = gmtime(&now);
  const int day_utc   = now_utc->tm_mday;
  const int month_utc = now_utc->tm_mon + 1;
  const int year_utc  = now_utc->tm_year + 1900;
	Serial.printf("_1900_now %d ", year_utc);		
        
  valueDim = BH1750Reading();
			
  u8g2.clearBuffer();
	u8g2.drawStr(45, 16, " connect.");		
	u8g2.setCursor(70, 48);
  u8g2.print(valueDim);
	u8g2.drawStr(100, 48, " lux" ); 
			
		//	StopWiFi();																			// [413] Reduces power consumption
	    				
	int core = xPortGetCoreID();
  Serial.print("\tMain code running on core ");
  Serial.println(core);
			
	Serial.print("Light: ");
  Serial.print(valueDim);
  Serial.print(" lux");
  			
	// float temperature = climateSensor.getTemperatureCelcius(true);
	Serial.print("\tTemperatura = ");
	Serial.print(climateSensor.getTemperatureCelcius(true));
	//	float humidity = climateSensor.getRelativeHumidity();
	Serial.print(", Humidity: ");
	Serial.print(climateSensor.getRelativeHumidity());
	//	float pressure = climateSensor.getPressure();
	Serial.print(" and Pressure: ");
	Serial.println(climateSensor.getPressure());
			
	displayTemperature();																						// [1740]
			
		// ---------------------------------------------
			// myPort.begin(9600, SWSERIAL_8N1, MYPORT_RX, MYPORT_TX, false, 95, 11);
			//	myPort.begin(9600);
	myPort.begin(9600, SWSERIAL_8N1, MYPORT_RX, MYPORT_TX);
				
	if (!myPort)  										// If the object did not initialize, then its configuration is invalid
	{
		Serial.println("Invalid SoftwareSerial pin configuration, check config"); 
		while (1)  											// Don't continue with invalid configuration
		{
			delay (1000);
		}
	} 
			
	delay(1000);			
	    
  Serial.print(F("Initializing DFPlayer Mini ... (May take 3~5 seconds ) "));
					
		// bool begin(Stream& stream, bool isACK = true, bool doReset = true);
  if (!myDFPlayer.begin(myPort, false, true)) {  // without ACK, doReset
				
    Serial.println(F("Unable to begin:"));
    Serial.println(F("1.Please recheck the connection!"));
    Serial.println(F("2.Please insert the SD card!"));
    while(true);
  }
  Serial.println(F("Mini online."));
		
	myDFPlayer.reset();     								//Reset the module	###
  myDFPlayer.setTimeOut(1000); 							//Set serial communictaion time out 500ms
					
  //----Set volume----
  myDFPlayer.volume(lls);  									//Set volume value (0~30).
  myDFPlayer.volumeUp(); 										//Volume Up
	
  myDFPlayer.volumeDown(); 									//Volume Down
	delay(500);			
		//----Set different EQ----
  myDFPlayer.EQ(DFPLAYER_EQ_NORMAL);
			//  myDFPlayer.EQ(DFPLAYER_EQ_POP);
			//  myDFPlayer.EQ(DFPLAYER_EQ_ROCK);
			//  myDFPlayer.EQ(DFPLAYER_EQ_JAZZ);
			//  myDFPlayer.EQ(DFPLAYER_EQ_CLASSIC);
			//  myDFPlayer.EQ(DFPLAYER_EQ_BASS);
						
	  //----Set device we use SD as default----
			//  myDFPlayer.outputDevice(DFPLAYER_DEVICE_U_DISK);
  myDFPlayer.outputDevice(DFPLAYER_DEVICE_SD);
			//  myDFPlayer.outputDevice(DFPLAYER_DEVICE_AUX);
			//  myDFPlayer.outputDevice(DFPLAYER_DEVICE_SLEEP);
			//  myDFPlayer.outputDevice(DFPLAYER_DEVICE_FLASH);
				
		//----Mp3 control----
			//  myDFPlayer.sleep();     //sleep
			//  myDFPlayer.reset();     //Reset the module
			//  myDFPlayer.enableDAC();  //Enable On-chip DAC
			//  myDFPlayer.disableDAC();  //Disable On-chip DAC
		 // myDFPlayer.outputSetting(true, 15); //output setting, enable the output and set the gain to 15
				
	/*
  //----Mp3 play----
  myDFPlayer.next();  //Play next mp3
  delay(1000);
  myDFPlayer.previous();  //Play previous mp3
  delay(1000);
  myDFPlayer.play(1);  //Play the first mp3
  delay(1000);
  myDFPlayer.loop(1);  //Loop the first mp3
  delay(1000);
  myDFPlayer.pause();  //pause the mp3
  delay(1000);
  myDFPlayer.start();  //start the mp3 from the pause
  delay(1000);
  myDFPlayer.playFolder(15, 4);  //play specific mp3 in SD:/15/004.mp3; Folder Name(1~99); File Name(1~255)
  delay(1000);
  myDFPlayer.enableLoopAll(); //loop all mp3 files.
  delay(1000);
  myDFPlayer.disableLoopAll(); //stop loop all mp3 files.
  delay(1000);
  myDFPlayer.playMp3Folder(4); //play specific mp3 in SD:/MP3/0004.mp3; File Name(0~65535)
  delay(1000);
  myDFPlayer.advertise(3); //advertise specific mp3 in SD:/ADVERT/0003.mp3; File Name(0~65535)
  delay(1000);
  myDFPlayer.stopAdvertise(); //stop advertise
  delay(1000);
  myDFPlayer.playLargeFolder(2, 999); //play specific mp3 in SD:/02/004.mp3; Name(1~10); Name(1~1000)
  delay(1000);
  myDFPlayer.loopFolder(5); //loop all mp3 files in folder SD:/05.
  delay(1000);
  myDFPlayer.randomAll(); //Random play all the mp3.
  delay(1000);
  myDFPlayer.enableLoop(); //enable loop.
  delay(1000);
  myDFPlayer.disableLoop(); //disable loop.
  delay(1000);
	*/
				
		//----Read imformation----
  Serial.printf("\t %d", myDFPlayer.readState()); 								//read mp3 state
  Serial.printf("\t %d", myDFPlayer.readVolume()); 								//read current volume
  Serial.printf("\t %d", myDFPlayer.readEQ()); 										//read EQ setting
  Serial.printf("\t %d", myDFPlayer.readFileCounts()); 						//read all file counts in SD card
  Serial.printf("\t %d", myDFPlayer.readCurrentFileNumber()); 		//read current play file number
			
  Serial.printf("\t %d", myDFPlayer.readFileCountsInFolder(12)); 	//read file counts in folder SD:/12
	Serial.printf("\t %d", myDFPlayer.readFileCountsInFolder(30)); 	//read file counts in folder SD:/30
	Serial.printf("\t %d", myDFPlayer.readFileCountsInFolder(40)); 	//read file counts in folder SD:/40
	Serial.printf("\t %d", myDFPlayer.readFileCountsInFolder(50)); 	//read file counts in folder SD:/50
				
	myDFPlayer.volume(lls);  																//Set volume value (0~30).
	delay(1000);
				
  myDFPlayer.playFolder(01, 0);														// play "0"
	    			
	u8g2.drawStr(3, 64, "mp3:");    												// status kol-wiersz
	u8g2.setCursor(40, 64);
  u8g2.print(lls);  
	u8g2.drawStr(70, 64, "0" );   													// status row.
	++bootCount;
	u8g2.drawStr(1, 16, "   ");   
  u8g2.drawStr(1, 16, "b: " );
	u8g2.setCursor(20, 16);
	u8g2.print(bootCount);	
		// u8g2.sendBuffer();																	// OLED display
  delay(1000); 
		
	Serial.printf("\n" D_STR_IRRECVDUMP_STARTUP "\n", kRecvPin);
  #if DECODE_HASH
				// Ignore messages with less than minimum on or off pulses.
  irrecv.setUnknownThreshold(kMinUnknownSize);
#endif  																									// DECODE_HASH
  irrecv.setTolerance(kTolerancePercentage);  						// Override the default tolerance.
  irrecv.enableIRIn();  																	// Start the receiver
	katalog = random(3, 5) * 10;														// katalog 30, 40, 50
	plik = random(0, 15);																		// plik 0 .. 15
	myDFPlayer.pause();  																		//pause the mp3
	stanMP3 = 1;																						// pause ?
							
	if ( bootCount >=	9	) bootCount = 1;
	u8g2.sendBuffer();																			// OLED display
			
	czasLoop = millis() + 600000;                            // 10 min. wlaczone Wifi dla OTA
  tempLoop = millis() + 1000;
		      	
	delay(100);	
	  //  for(;;);      
}	// ------- end-setup ----------------
			
	// --------------------------------------------------- loop ------------------------------------------------
void loop()
{			
	obslugaOTA();																		// ###	    
	static bool skocz = 1;
	static byte lastSek = 1;
	static byte liczba = random(1, 10);
	static byte listaKat = 1;
	static int tempX = katalog;
	static int tempY = plik;
	static int kontrast;
	int odczytTime;
	static bool odtworzCzas = 0;
	static int tempLLS = 4;
	static uint64_t IRcode;
  static bool monostabilny = 1;
	static bool setaState = 0;                        // klawisz "100" wybor animationState 0 .. 3
	static bool setsRGB = 0;                          // klawisz "200" wybor RGBState 0 .. 7 
	static bool eqRestart = 0;
	static bool eqSecur = 0;
	static bool zegarON = 0;													// zegarek wyswietl w nocy 
	static bool rgbON = 0;														// RGB wyswietl w nocy
	static bool keyLong = 0;													// zmniejsz jasnosc RGB w dzien
	static int eq_Licz = 0;
	static unsigned long int czasTemp = 0;
 				
  climateSensor.takeForcedMeasurement();            // one can also use one of getTemperature(true)    
      				
		// --------------------- DFPlayer ----------------------
  if (myDFPlayer.available() && night == 0 && nightOFF == 0) {        // gramy tylko w dzien.
		if( (myDFPlayer.readType() == 5) || (myDFPlayer.readType() == 6) || (myDFPlayer.readType() == 0)) {
			if (odtworzCzas == 0) plik = plik + 1;												// nastepny plik
			if (plik > 15) plik = 0;
				//  Serial.printf("_2144_ odtworzCzas plik %d - %d \n", odtworzCzas, plik);
			if (stanMP3 == 0) myDFPlayer.playFolder(katalog, plik );  		// brak pauzy, play mp3 in SD: 30, 40, 50
		}
	}
      
  if (millis() > czasLoop && onWiFi) {    
    StopWiFi();                                                       // [413] Reduces power consumption    
    onWiFi = 0;
		counter++;																					              // Increase counter by 1
		preferences.putUInt("counter", counter);			                    // Store the counter to the Preferences
		preferences.end();														                    // Close the Preferences
		Serial.printf("_2156_ counter value: %u\n", counter);
  } 
  						
    // ------------ OLED co 1000 msec ---------    
	if ( millis() > tempLoop) {
		time(&now);                                         // read the current time
    localtime_r(&now, &tm);                             // update the structure tm with the current time    
		ProcessTime();                                      // [876] uaktualnij secCalc, minCalc
		u8g2.clearBuffer();
      
    if (zegarON) {                                      // bezwzglednie wyswietl Zegar  
      String zegarek = String(godzina()) + ":" + twoDigits(minuta()) + ":" + twoDigits(sekunda()); // [1778]
              
      u8g2.drawStr(1, 16, "b: " );
      u8g2.setCursor(20, 16);
      u8g2.print(bootCount);
      u8g2.setCursor(35, 16);
      u8g2.print(zegarek);  
      u8g2.sendBuffer();                                // OLED display odswierz 
    }
					
		if ( night == 0 && nightOFF == 0) {									// dzien ?
			String zegarek = String(godzina()) + ":" + twoDigits(minuta()) + ":" + twoDigits(sekunda()); // [1778]
							
			u8g2.drawStr(1, 16, "b: " );
			u8g2.setCursor(20, 16);
			u8g2.print(bootCount);
			u8g2.setCursor(35, 16);
			u8g2.print(zegarek);
          
      if ( wahadlo == 0 ) u8g2.drawStr(100, 16, "B" );    // wahadlo zablokowane.
			if (podajCzas == 0 ) u8g2.drawStr(110, 16, "T" );	 // podajCzas zablokowany
			if (eqSecur) u8g2.drawStr(120, 16, "S:" );				   // security zablokowana klawiatura IR 							
			                 
			kontrast = BH1750Reading();                           // odczyt oswietlenia
      valueDim = kontrast;
      if (keyLong == 1) {
        valueDim = nightRGB + 2 ;														// balans dziala
      }
			        
			u8g2.setCursor(70, 48);
			u8g2.print(kontrast);
			u8g2.drawStr(100, 48, " lux" );
			u8g2.setContrast(kontrast / 4);                       // kontrast OLED
					
			displayTemperature();            											// [1740] wyswietl co 10 sek.
						
			u8g2.drawStr(1, 64, "mp3");    												// MP3                     
			u8g2.setCursor(37, 64);
			u8g2.print(lls);																			// volume stan.
			String stat = String(katalog) + "." + String(plik);	// katalog, plik
			u8g2.setCursor(60, 64);
			u8g2.print(stat);																		  // wyswietl katalog, plik
      u8g2.setCursor(103, 64);
      u8g2.print(animationState);                           // wyswietl numer animationState
      u8g2.drawStr(110, 64, "-");
      u8g2.setCursor(115, 64);
      u8g2.print(stateRGB);                                 // wyswietl numer stateRGB
          
			if(twoDigits(sekunda() ) == "00" )	{                 // kasuj wybranie "100", "200"
				//setaState = 0;
				//setsRGB = 0;
		  } 
					
			valueDim = map(valueDim, 0, 255, 0, 255);					      // blend(0, 255) --> 0--255
			//  Serial.printf("_2228_ %d \t", valueDim);
		} // ----------- end_dzien -------------
		u8g2.sendBuffer();                                      // OLED display odswierz
		CheckAutoDim();																		      // [670]	
    tempLoop = millis() + 1000;
  } // --------- end_millis() ---------
					
					
	if( secCalc%5 == 0 && eq_Licz > 0) {                      // 5 sekund na wprowadzenie kodu
	  eq_Licz = 0;
    zegarON = 0;
	} 
           
		// ---------- nightOFF --------------			
	if (nightOFF || rgbON) {                                         // jest noc
				
		if( (minCalc%5 == 0 && secCalc == 5 && monostabilny) || (rgbON && monostabilny) ) {
		  czas1 = millis()+ 5000;                          // co 5 minut, wyswietl czas na 5 sekund.
			monostabilny = 0; 															 // klawiszem "1" rgbON wyswietl czas na 5 sekund.	
			  // Serial.printf("_2210_ %d - %d \n", rgbON, czas1 );
		}
						
		if ( (minCalc%5 == 0 && secCalc == 10 && (monostabilny == 0) ) || (rgbON && monostabilny == 0) ) {
      monostabilny = 1;
			rgbON = 0;
		  	// Serial.printf("_2220_ %d - %d \n", millis(), czas1);
		}	
            
		if (millis() < czas1)	{                             // wyswietl czas przez 5 sek na OLED
			if (valueDim < 1) valueDim = nightRGB;
			dimBrightness = valueDim;													// default == 1
			totalBrightness = nightRGB; 	                    // org 1
        // if( millis()%2000 == 0 ) Serial.println("_2225_");
		}else {
      valueDim = 0;
      totalBrightness = 0;
      dimBrightness = 0;
			rgbON = 0;
    }
	}		
				
		// ------ podaj aktualny czas -----	
	if( minCalc%15 == 0 && podajCzas )  							// co 15 minut podaj czas glosowo  								 
	{
		odtworzCzas = 1;	
			// ---------------------
		if( secCalc == 0 && zero == 1)      
		{
				//	Serial.print("_2240_");
			zero = 0;
			tempX = katalog;
			tempY = plik;
			tempLLS = lls;
			myDFPlayer.pause();  														// zapisz paramery - pause
		}
			// -------------------	
		if( secCalc == 1 && jeden == 1)       
		{
				//	Serial.print("_2250_");
			jeden = 0;
			myDFPlayer.volume(20);  												// volume
		}		
			// -------------------	
		if( secCalc == 2 && dwa == 1)        
		{
				//	Serial.print("_2260_");
			dwa = 0;
			odczytTime = hourDirectCalc * 10 + minCalc/15;
			myDFPlayer.playFolder(12, odczytTime);  					// odczytaj aktualny czas z katalogu 12	
		}		
			// -----------------------
		if( secCalc == 5 && piec == 1)      							
		{
				//	Serial.print("_2266_ ");
			piec = 0;																						// 5 sekunda
			lls = tempLLS;
			myDFPlayer.volume(lls);  
			delay(700);																					// org 500 msec
			plik = tempY;																				// 
			katalog = tempX;																		// przywroc parametry
		  odtworzCzas = 0;																		// blokuj kolejne odtwarzanie czasu
		}	
					
	}	// ----------------- end-if-minCalc%15 --------
			
	if (hourDirectCalc == 9 && minCalc == 5 || hourDirectCalc == 14 && minCalc == 5 || eqRestart == 1 ) {																								// restart o 9:05, 14:05, nacisniecie klawisza EQ 4 x
		RestartDevice();
	}
		
		// ----------- 59 ------------
			// if ( secCalc > 57 && secCalc <= 59) 						
	if ( secCalc == 59) 	
	{
		zero = 1;
		jeden = 1;
		dwa = 1;
		trzy = 1;
		cztery = 1;
		piec = 1;
		odtworzCzas = 0;
		zegarON = 0;
  }	
		
		// --------------- IR ---------------------------------				
  if (irrecv.decode(&results)) {														// Check if the IR code has been received.
	  uint32_t tnow = millis();																// Display a crude timestamp.
			//	Serial.printf(D_STR_TIMESTAMP " : %06u.%03u\n", tnow / 1000, tnow % 1000);
					// Check if we got an IR message 
    if (results.overflow)
      Serial.printf(D_WARN_BUFFERFULL "\n", kCaptureBufferSize);
					// Display the library version the message was captured with.
			//	Serial.println(D_STR_LIBRARY "   : v" _IRREMOTEESP8266_VERSION_STR "\n");
					// Display the tolerance percentage if it has been change from the default.
    if (kTolerancePercentage != kTolerance)
      Serial.printf(D_STR_TOLERANCE " : %d%%\n", kTolerancePercentage);
					// Display the basic output of what we found.
			//	Serial.println("_2319_ code: ");       
			//	Serial.print(resultToHumanReadableBasic(&results));
		IRcode = results.value;
	        
		  //  Serial.printf("_2349_ IRcode: %#x \n", IRcode);       
						// Display any extra A/C info if we have it.
    String description = IRAcUtils::resultAcToString(&results);
    if (description.length()) Serial.println(D_STR_MESGDESC ": " + description);
    yield();  // Feed the WDT as the text output can take a while to print.
#if LEGACY_TIMING_INFO
					// Output legacy RAW timing info of the result.
			//	Serial.println(resultToTimingInfo(&results));
    yield();                                      // Feed the WDT (again)
#endif  	// LEGACY_TIMING_INFO
					// Output the results as source code
			//	 Serial.println(resultToSourceCode(&results));
		yield();             													// Feed the WDT (again)
			 
		if (IRcode < 0xFFFFFF) {
			if ( (night == 1 || nightOFF == 1) && IRcode != 0xFF906F ) {
				rgbON = 1;																// RGB wyswietl w nocy nie ruszaj EQ
			  Serial.printf("_2355_   %d\n", rgbON);
			}
						
			if (IRcode == 0xFF906F) {										// EQ
					eq_Licz += 1;
					if (eq_Licz == 1) zegarON = 1;					// zegar wyswietl np. w nocy
					if (eq_Licz == 2) {											// blokuj podawanie czasu
					  podajCzas = !podajCzas;
            zegarON = 0;
					}
					if (eq_Licz == 3) {											// security, blokuj klawisze
					  podajCzas = !podajCzas;
					  eqSecur = !eqSecur;
            zegarON = 0;
					}
					if (eq_Licz == 4) eqRestart = 1;				// restart na zyczenie
			}	
			if (eqSecur == 0 ) {															// przy EQ pomin inne klawisze ###
				switch(IRcode) {
					case 0xFF9867:																// klawisz 100+
						animationState -=1;
						if (animationState <= -1) animationState = 8;
            stateRGB = 2;
					break;
					case 0xFFB04F:																// klawisz 200+
						stateRGB -=1;
						if (stateRGB <= -1) stateRGB = 4;
            animationState = 1;
					break;
					case 0xFFE01F:																// "-"
						lls -= 1;
						if(lls < 2) lls = 1;
						myDFPlayer.volume(lls);  																//Set volume value (0~30).
					break;
					case 0xFFA857:																// "+"
						lls += 2;
						if(lls > 30) lls = 25;
						myDFPlayer.volume(lls);  																//Set volume value (0~30).
					break;
					case 0xFFA25D:																// CH+
						katalog = katalog + 10;
						if (katalog > 50) katalog = 30;
					break;
					case 0xFFE21D:																// CH-
						katalog = katalog - 10;
						if (katalog < 30) katalog = 50;
					break;
					case 0xFF629D:																// CH	stop Mp3			
						myDFPlayer.pause();  												//pause the mp3
						stanMP3 = 1;																// pause.
					break;
					case 0xFF22DD:																// |<<
						plik = plik - 1;
						if (plik < 0) plik = 15;
					break;
					case 0xFF02FD:																// >>|
						plik = plik + 1;
						if (plik > 15) plik = 0;
					break;
					case 0xFFC23D:																// >|	start from pause Mp3			
						myDFPlayer.playFolder(katalog, plik );      //play specific mp3 in SD:/xx/00x.mp3;
						stanMP3 = 0;																// play.
					break;
					case 0xFF6897:																// "0" stop/start pendant (wahadlo)			
						wahadlo = !wahadlo;
					break;
					case 0xFF30CF:																// "1" 	zmien katalog bajek 05 / 06	
						claps = !claps;
					break;
					case 0xFF18E7:																// "2" 		
						if (claps) myDFPlayer.playFolder(06, 2);
						else myDFPlayer.playFolder(05, 002);
					break;		
					case 0xFF7A85:																// "3" 		
						if (claps) myDFPlayer.playFolder(06, 003);
						else myDFPlayer.playFolder(05, 003);
					break;		
					case 0xFF10EF:																// "4" 		
						if (claps) myDFPlayer.playFolder(06, 004);
						else myDFPlayer.playFolder(05, 004);
					break;		
					case 0xFF38C7:																// "5" 		
						if (claps) myDFPlayer.playFolder(06, 005);
						else myDFPlayer.playFolder(05, 005);
					break;		
					case 0xFF5AA5:																// "6" 		
						if (claps) myDFPlayer.playFolder(06, 6);
						else myDFPlayer.playFolder(05, 6);
					break;		
					case 0xFF42BD:																// "7" 		
						if (claps) myDFPlayer.playFolder(06, 7);
						myDFPlayer.playFolder(05, 7);
					break;	
					case 0xFF4AB5:																// "8" 		
						if (claps) myDFPlayer.playFolder(06, 8);
						else myDFPlayer.playFolder(05, 8);	
					break;		
					case 0xFF52AD:																// "9" 		
						if (claps) myDFPlayer.playFolder(06, 9);
						else myDFPlayer.playFolder(05, 9);	
					break;		
						
					default:
						animationState = 1;
						stateRGB = 2;
				}	// --------- switch --------------------	
			}	// ------------ if_eqSecur==1 ----------------	
										
		  Serial.printf("_2471_ setaState, setsRGB %d - %d ", setaState, setsRGB);
			Serial.printf("_2472_ anima RGBst IRcode %d - %d - %x  \n", animationState, stateRGB, IRcode);     
			// Serial.printf("_2470_ eqSecur eq_Licz IRcode %d - %d - %x  \n", eqSecur, eq_Licz, IRcode);     
		}		// ----------- f_ircode<0xffffff-------------	
		else {																								// kody powtarzania 0xFFFFFFFF
			keyLong = !keyLong;
			if (keyLong == 1) {
			  dimBrightness = nightRGB;													// default == 1
			  totalBrightness = nightRGB; 	                    // org 1
			} // --- end_if --- 
				//	Serial.printf("_2450_ keyLong %d \n", keyLong);    
		} // -- end_else ------
  }		// -------------------- end_IR -------------
}	// ----------------------------------- end_loop -----------------------------------------------
// -------------------------------- end ----------------------------------------
